import 'package:flutter/foundation.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:get/get.dart';

abstract class Service {
  Map<String, String> post(int i);
}

class Api implements Service {
  @override
  Map<String, String> post(int i) {
    if (i == 0) {
      return {"Api_status": "200"};
    } else if (i == 1) {
      return {"Api_status": "400"};
    } else {
      return null;
    }
  }
}

class Controller extends GetController {
  Map<String, String> data;
  void getData(int i) {
    data = Get.find<Service>().post(i);
  }
}

void main() {
  Get.lazyPut<Controller>(() => Controller());
  Get.lazyPut<Service>(() => Api());

  test('Test 1', () {
    var service = Get.find<Service>();
    expect(service.post(0), {"Api_status": "200"});
    expect(service.post(1), {"Api_status": "400"});
    expect(service.post(2), null);
  });

  test('Test 2', () {
    var controller = Get.find<Controller>();
    controller.getData(0);
    expect(controller.data, {"Api_status": "200"});
    controller.getData(1);
    expect(controller.data, {"Api_status": "400"});
    controller.getData(2);
    expect(controller.data, null);
  });

  test('User Rx', () {
    final user = User();
    print(user.name);
    user.age = 23;
    user.rx.age.listen((int v) => print(v)); // => 20, 25
    user.age = 24;
    user.age = 25;
  });
}

class RxUser {
  final name = "Camila".obs;
  final age = 18.obs;
}

class User {
  User({String name, int age});
  final rx = RxUser();

  String get name => rx.name.value;
  set name(String value) => rx.name.value = value;

  int get age => rx.age.value;
  set age(int value) => rx.age.value = value;
}

class ChangeNOti extends ChangeNotifier{

}
